//
//  NetworkServer.h
//  NetworkAPI
//
//  Created by Ger Teunis on 16-08-12.
//  Copyright (c) 2013 VortexApps. All rights reserved.
//

#import "NetworkAPIHandlerProtocol.h"
#import <Foundation/Foundation.h>
@class HTTPServer;


@interface NetworkAPIServer : NSObject {
    HTTPServer *httpServer;
    NSObject<NetworkAPIHandlerProtocol>* handler;
    NSString *documentRoot;
    ushort _tcpPort;
    NSString *remoteApiKey;
    bool sslEnabled;
    NSArray *sslCertificate;
    NSArray *whiteListedIPs;
}

@property (strong) HTTPServer *httpServer;
@property (readonly) NSObject<NetworkAPIHandlerProtocol>* handler;
@property (strong) NSString *documentRoot;
@property (strong) NSString *remoteApiKey;
@property (assign) bool sslEnabled;
@property (strong) NSArray *whiteListedIPs;

-(NSArray *)sslIdentityAndCertificates;
+(NetworkAPIServer*)sharedInstance;
-(void)startServer;
-(void)stopServer;
-(id)initWithHandler:(NSObject<NetworkAPIHandlerProtocol>*)h
   usingDocumentRoot:(NSString*)docroot
             tcpPort:(ushort)tcpPort
          sslEnabled:(bool)_sslEnabled
              apiKey:(NSString*)apiKey
      whiteListedIPs:(NSArray*)whiteListedIPs;

@end
